#!/usr/bin/python

import sys, re, os;

def memsat1res2top(strMemsat, strOutFile) :
    ptnSeqLength = re.compile('(\d+) residues');
    ptnFinal = re.compile('FINAL PREDICTION');
    ptnHelix = re.compile('\d+\:');
    ptnNterm = re.compile('\d+\: \((\w+)\)');
    ptnHelixStartEnd = re.compile('\d+\: (\(\w+\) )?(\d+)-(\d+)');

    flhMemsat = file(strMemsat, 'r');

    strRawTopo = '';
    intLineCount = 0;
    strLine = flhMemsat.readline();


    # Get seq length
    while ( not ptnSeqLength.match(strLine) and len(strLine) > 0 ) :
        intLineCount += 1;
        strLine = flhMemsat.readline();
    intSeqLength = int( ptnSeqLength.match(strLine).group(1) );
    if intSeqLength < 30 :
        flhMemsat.close();
        print >>sys.stderr, "%s: Sequence length less than 30: quitting" % strMemsat;
        return ;
    intTitleLine = intLineCount - 1; # previous line from seq length


    # Get helices
    while ( not ptnFinal.match(strLine) and len(strLine) > 0 ) :
        strLine = flhMemsat.readline();
    strFoo = flhMemsat.readline();
    strLine = flhMemsat.readline();
    while ( ptnHelix.match(strLine) and len(strLine) > 0 ) :
        strRawTopo += strLine;
        strLine = flhMemsat.readline();

    # Get title
    flhMemsat.seek(0);
    strTitle = flhMemsat.readlines()[intTitleLine].strip();

    flhMemsat.close();


    arrRawTopo = strRawTopo.split('\n');

    # Prepare for snipped code
    strNterm = ptnNterm.match(arrRawTopo[0]).group(1).upper();
    lstHelixPos = [];
    for helix in arrRawTopo :
        if ( len(helix) > 0 ) :
            m = ptnHelixStartEnd.match(helix);
            lstHelixPos.append( m.group(2) );
            lstHelixPos.append( m.group(3) );

    ## snipped from hmmtopres2top.py

    def toggleNonMembraneChar(chrCurrent) :
        if ( chrCurrent == 'i' ) :
            return 'o';
        return 'i';

    # Get predicted topology string
    # Init char to use in between TM-regions, TM-label, strTopo
    if ( strNterm == "IN" ) :
        chrNonMembrane = 'i';
    else :
        chrNonMembrane = 'o';
    chrMembrane = 'M';
    strTopo = '';

    # Snip off the two first elements in lstHelixPos and use the values to add one
    # non-TM region and one TM-region to strTopo. Pad strTopo with non-TM labels
    # when out of TM-regions until it is as long as the query sequence.
    while ( len(lstHelixPos) > 0 and len(lstHelixPos) % 2 == 0) :
        intStart = int(lstHelixPos[0]);
        intEnd = int(lstHelixPos[1]);
        strTopo += chrNonMembrane * ( (intStart - 1) - len(strTopo));
        strTopo += chrMembrane * (intEnd - intStart + 1);
        chrNonMembrane = toggleNonMembraneChar(chrNonMembrane);
        lstHelixPos = lstHelixPos[2:];
    strTopo += chrNonMembrane * (intSeqLength - len(strTopo));

    # Write to file
    flhTop = file(strOutFile, 'w');
    print >>flhTop, ">%s\n%s" % (strTitle, strTopo);
    flhTop.close();


if __name__ == '__main__' :
    strUsage = "Usage: %s <memsat result file> <output file>";
    if ( len(sys.argv) < len(strUsage.split('<')) ) :
        print strUsage % os.path.basename(sys.argv[0]);
        sys.exit(1);

    memsat1res2top(sys.argv[1], sys.argv[2]);
